diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index 2e7c9c8bb18..ff4b2abd20c 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -459,72 +459,89 @@ expected_filters_selectivity(List *filters)
 	return sel;
 }
 
+/*
+ * Estimated cost of probing one Bloom filter for one tuple.  A probe (a few
+ * hash evaluations and bit tests) is cheaper than a full hash-table lookup,
+ * so we charge less than cpu_operator_cost per probe; the bottom-up Bloom
+ * filter paper likewise sets its per-filter probe cost below a hash probe.
+ */
+#define BLOOM_FILTER_PROBE_COST (cpu_operator_cost * 0.5)
+
+/*
+ * apply_expected_filters
+ *	  Adjust an already-costed path to account for probing the given set of
+ *	  Bloom filters against the tuples it produces, and record them as the
+ *	  path's expected_filters.
+ *
+ * This is the generic, not-smart costing fallback.  Filters are probed most
+ * selective first (see find_bloom_filter_combinations and, at execution,
+ * ExecInitBloomFilters), and a tuple rejected by one filter is not probed by
+ * the later ones.  So the expected number of probes per input tuple is the
+ * sum, over the filters, of the fraction of tuples that survive all earlier
+ * filters -- far fewer than one probe per filter once the filters are
+ * selective.  We charge BLOOM_FILTER_PROBE_COST per probe, on top of shrinking
+ * the row estimate by the filters' combined selectivity.
+ *
+ * Callers that can do something smarter (e.g. a CustomScan skipping whole row
+ * groups via a zone map) should cost themselves instead of using this.
+ */
+void
+apply_expected_filters(Path *path, List *filters)
+{
+	double		probes = 0.0;
+	double		surviving = 1.0;
+	ListCell   *lc;
+
+	if (filters == NIL)
+		return;
+
+	foreach(lc, filters)
+	{
+		ExpectedFilter *f = (ExpectedFilter *) lfirst(lc);
+
+		probes += surviving;
+		surviving *= f->selectivity;
+	}
+
+	path->total_cost += probes * BLOOM_FILTER_PROBE_COST * path->rows;
+	path->rows = clamp_row_est(path->rows * surviving);
+	path->expected_filters = filters;
+}
+
 /*
  * create_filtered_scan_path
- *	  Build a copy of a base-relation scan path that additionally expects the
- *	  given set of pushed-down Bloom filters.
+ *	  Build a copy of an IndexPath that additionally expects the given set of
+ *	  pushed-down Bloom filters.
  *
  * The clone shares all substructure with the original path (parent,
- * pathtarget, clauses, etc.); only the rows estimate is reduced to reflect
- * the filters' combined selectivity, and expected_filters is set.  This is
- * safe because create_plan() treats the clone identically to the original
- * (it ignores expected_filters), and add_path() may freely pfree the clone.
- *
- * Only the plain scan path node types that can receive a pushed-down filter
- * are supported (matching find_bloom_filter_recipient in createplan.c).
- * Returns NULL for unsupported path types.
+ * pathtarget, indexclauses, pathkeys, etc.); we reuse the source path's
+ * already-derived indexclauses/pathkeys and its cost rather than rebuilding
+ * them, and then apply_expected_filters() makes the same cost/rows adjustment
+ * core makes for every other scan type -- charging the per-tuple probe cost
+ * and shrinking the row estimate.  This is safe because create_plan() treats
+ * the clone identically to the original (it ignores expected_filters), and
+ * add_path() may freely pfree the clone.
  *
- * XXX This should probably adjust the CPU cost in some way. It assumes the
- * filter checks are free, which does not seem right.
+ * Other base-relation scan path types are built directly by their real
+ * constructors with the filters passed in (see create_seqscan_path,
+ * create_bitmap_heap_path, etc.); IndexPath is the exception because
+ * create_index_path() would re-derive its indexclauses/pathkeys from scratch
+ * -- see the comment on the T_IndexScan/T_IndexOnlyScan case in
+ * reparameterize_path() for the same tradeoff made there.
  */
 Path *
 create_filtered_scan_path(PlannerInfo *root, Path *subpath, List *filters)
 {
-	Path	   *newpath;
-	size_t		sz;
+	IndexPath  *newpath;
 
-	switch (nodeTag(subpath))
-	{
-		case T_Path:
-			/* plain seqscan/samplescan etc. */
-			sz = sizeof(Path);
-			break;
-		case T_IndexPath:
-			sz = sizeof(IndexPath);
-			break;
-		case T_BitmapHeapPath:
-			sz = sizeof(BitmapHeapPath);
-			break;
-		case T_TidPath:
-			sz = sizeof(TidPath);
-			break;
-		case T_TidRangePath:
-			sz = sizeof(TidRangePath);
-			break;
-		case T_CustomPath:
-
-			/*
-			 * A base-relation CustomScan provider that advertised
-			 * CUSTOMPATH_SUPPORT_BLOOM_FILTERS can receive a pushed-down
-			 * filter and apply it in its own scan loop
-			 * .generate_expected_filter_paths() only offers such paths here,
-			 * so we need not re-check the flag.
-			 */
-			sz = sizeof(CustomPath);
-			break;
-		default:
-			/* unsupported scan path type */
-			return NULL;
-	}
+	Assert(IsA(subpath, IndexPath));
 
-	newpath = (Path *) palloc(sz);
-	memcpy(newpath, subpath, sz);
+	newpath = (IndexPath *) palloc(sizeof(IndexPath));
+	memcpy(newpath, subpath, sizeof(IndexPath));
 
-	newpath->expected_filters = filters;
-	newpath->rows = clamp_row_est(subpath->rows *
-								  expected_filters_selectivity(filters));
+	apply_expected_filters(&newpath->path, filters);
 
-	return newpath;
+	return (Path *) newpath;
 }
 
 /*
@@ -1254,7 +1271,8 @@ add_partial_path_precheck(RelOptInfo *parent_rel, int disabled_nodes,
  */
 Path *
 create_seqscan_path(PlannerInfo *root, RelOptInfo *rel,
-					Relids required_outer, int parallel_workers)
+					Relids required_outer, int parallel_workers,
+					List *filters)
 {
 	Path	   *pathnode = makeNode(Path);
 
@@ -1269,6 +1287,7 @@ create_seqscan_path(PlannerInfo *root, RelOptInfo *rel,
 	pathnode->pathkeys = NIL;	/* seqscan has unordered result */
 
 	cost_seqscan(pathnode, root, rel, pathnode->param_info);
+	apply_expected_filters(pathnode, filters);
 
 	return pathnode;
 }
@@ -1278,7 +1297,8 @@ create_seqscan_path(PlannerInfo *root, RelOptInfo *rel,
  *	  Creates a path node for a sampled table scan.
  */
 Path *
-create_samplescan_path(PlannerInfo *root, RelOptInfo *rel, Relids required_outer)
+create_samplescan_path(PlannerInfo *root, RelOptInfo *rel,
+					   Relids required_outer, List *filters)
 {
 	Path	   *pathnode = makeNode(Path);
 
@@ -1293,6 +1313,7 @@ create_samplescan_path(PlannerInfo *root, RelOptInfo *rel, Relids required_outer
 	pathnode->pathkeys = NIL;	/* samplescan has unordered result */
 
 	cost_samplescan(pathnode, root, rel, pathnode->param_info);
+	apply_expected_filters(pathnode, filters);
 
 	return pathnode;
 }
@@ -1381,7 +1402,8 @@ create_bitmap_heap_path(PlannerInfo *root,
 						Path *bitmapqual,
 						Relids required_outer,
 						double loop_count,
-						int parallel_degree)
+						int parallel_degree,
+						List *filters)
 {
 	BitmapHeapPath *pathnode = makeNode(BitmapHeapPath);
 
@@ -1400,6 +1422,7 @@ create_bitmap_heap_path(PlannerInfo *root,
 	cost_bitmap_heap_scan(&pathnode->path, root, rel,
 						  pathnode->path.param_info,
 						  bitmapqual, loop_count);
+	apply_expected_filters(&pathnode->path, filters);
 
 	return pathnode;
 }
@@ -1514,7 +1537,7 @@ create_bitmap_or_path(PlannerInfo *root,
  */
 TidPath *
 create_tidscan_path(PlannerInfo *root, RelOptInfo *rel, List *tidquals,
-					Relids required_outer)
+					Relids required_outer, List *filters)
 {
 	TidPath    *pathnode = makeNode(TidPath);
 
@@ -1532,6 +1555,7 @@ create_tidscan_path(PlannerInfo *root, RelOptInfo *rel, List *tidquals,
 
 	cost_tidscan(&pathnode->path, root, rel, tidquals,
 				 pathnode->path.param_info);
+	apply_expected_filters(&pathnode->path, filters);
 
 	return pathnode;
 }
@@ -1544,7 +1568,7 @@ create_tidscan_path(PlannerInfo *root, RelOptInfo *rel, List *tidquals,
 TidRangePath *
 create_tidrangescan_path(PlannerInfo *root, RelOptInfo *rel,
 						 List *tidrangequals, Relids required_outer,
-						 int parallel_workers)
+						 int parallel_workers, List *filters)
 {
 	TidRangePath *pathnode = makeNode(TidRangePath);
 
@@ -1562,6 +1586,7 @@ create_tidrangescan_path(PlannerInfo *root, RelOptInfo *rel,
 
 	cost_tidrangescan(&pathnode->path, root, rel, tidrangequals,
 					  pathnode->path.param_info);
+	apply_expected_filters(&pathnode->path, filters);
 
 	return pathnode;
 }
@@ -4176,9 +4201,9 @@ reparameterize_path(PlannerInfo *root, Path *path,
 	switch (path->pathtype)
 	{
 		case T_SeqScan:
-			return create_seqscan_path(root, rel, required_outer, 0);
+			return create_seqscan_path(root, rel, required_outer, 0, NIL);
 		case T_SampleScan:
-			return create_samplescan_path(root, rel, required_outer);
+			return create_samplescan_path(root, rel, required_outer, NIL);
 		case T_IndexScan:
 		case T_IndexOnlyScan:
 			{
@@ -4206,7 +4231,7 @@ reparameterize_path(PlannerInfo *root, Path *path,
 														rel,
 														bpath->bitmapqual,
 														required_outer,
-														loop_count, 0);
+														loop_count, 0, NIL);
 			}
 		case T_SubqueryScan:
 			{
diff --git a/src/include/lib/bloomfilter.h b/src/include/lib/bloomfilter.h
index 9277087acb6..9a79e83e7d9 100644
--- a/src/include/lib/bloomfilter.h
+++ b/src/include/lib/bloomfilter.h
@@ -17,6 +17,10 @@ typedef struct bloom_filter bloom_filter;
 
 extern bloom_filter *bloom_create(int64 total_elems, int bloom_work_mem,
 								  uint64 seed);
+extern bloom_filter *bloom_create_custom(int64 total_elems, int bloom_work_mem,
+										 uint64 min_bitset_bytes,
+										 int max_hash_funcs,
+										 uint64 seed);
 extern void bloom_free(bloom_filter *filter);
 extern void bloom_add_element(bloom_filter *filter, unsigned char *elem,
 							  size_t len);
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index 44c72e238cf..9fc7a11313c 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -1070,6 +1070,16 @@ typedef struct RelOptInfo
 	struct Path *cheapest_total_path;
 	List	   *cheapest_parameterized_paths;
 
+	/*
+	 * Cache of the interesting Bloom filters this rel could receive from a
+	 * hash join above it. Computed lazily and reused, since both core path
+	 * generation and a CustomScan provider may ask for it, and recomputing it
+	 * is not free. A separate "valid" flag distinguishes "not yet computed"
+	 * from "computed, no filters".
+	 */
+	List	   *bloom_filters pg_node_attr(read_write_ignore);
+	bool		bloom_filters_valid pg_node_attr(read_write_ignore);
+
 	/*
 	 * parameterization information needed for both base rels and join rels
 	 * (see also lateral_vars and lateral_referencers)
diff --git a/src/include/optimizer/pathnode.h b/src/include/optimizer/pathnode.h
index f747f204184..97ff59cacda 100644
--- a/src/include/optimizer/pathnode.h
+++ b/src/include/optimizer/pathnode.h
@@ -66,13 +66,15 @@ extern bool add_partial_path_precheck(RelOptInfo *parent_rel,
 
 extern bool expected_filters_equal(List *a, List *b);
 extern double expected_filters_selectivity(List *filters);
+extern void apply_expected_filters(Path *path, List *filters);
 extern Path *create_filtered_scan_path(PlannerInfo *root, Path *subpath,
 									   List *filters);
 
 extern Path *create_seqscan_path(PlannerInfo *root, RelOptInfo *rel,
-								 Relids required_outer, int parallel_workers);
+								 Relids required_outer, int parallel_workers,
+								 List *filters);
 extern Path *create_samplescan_path(PlannerInfo *root, RelOptInfo *rel,
-									Relids required_outer);
+									Relids required_outer, List *filters);
 extern IndexPath *create_index_path(PlannerInfo *root,
 									IndexOptInfo *index,
 									List *indexclauses,
@@ -89,7 +91,8 @@ extern BitmapHeapPath *create_bitmap_heap_path(PlannerInfo *root,
 											   Path *bitmapqual,
 											   Relids required_outer,
 											   double loop_count,
-											   int parallel_degree);
+											   int parallel_degree,
+											   List *filters);
 extern BitmapAndPath *create_bitmap_and_path(PlannerInfo *root,
 											 RelOptInfo *rel,
 											 List *bitmapquals);
@@ -97,12 +100,14 @@ extern BitmapOrPath *create_bitmap_or_path(PlannerInfo *root,
 										   RelOptInfo *rel,
 										   List *bitmapquals);
 extern TidPath *create_tidscan_path(PlannerInfo *root, RelOptInfo *rel,
-									List *tidquals, Relids required_outer);
+									List *tidquals, Relids required_outer,
+									List *filters);
 extern TidRangePath *create_tidrangescan_path(PlannerInfo *root,
 											  RelOptInfo *rel,
 											  List *tidrangequals,
 											  Relids required_outer,
-											  int parallel_workers);
+											  int parallel_workers,
+											  List *filters);
 
 extern AppendPath *create_append_path(PlannerInfo *root, RelOptInfo *rel,
 									  AppendPathInput input,
diff --git a/src/include/optimizer/paths.h b/src/include/optimizer/paths.h
index b153df758b3..2ec8a3bf928 100644
--- a/src/include/optimizer/paths.h
+++ b/src/include/optimizer/paths.h
@@ -61,6 +61,7 @@ extern PGDLLIMPORT join_search_hook_type join_search_hook;
 extern RelOptInfo *make_one_rel(PlannerInfo *root, List *joinlist);
 extern RelOptInfo *standard_join_search(PlannerInfo *root, int levels_needed,
 										List *initial_rels);
+extern List *find_bloom_filter_combinations(PlannerInfo *root, RelOptInfo *rel);
 
 extern void generate_gather_paths(PlannerInfo *root, RelOptInfo *rel,
 								  bool override_rows);
diff --git a/src/test/modules/test_bloom_customscan/sql/test_bloom_customscan.sql b/src/test/modules/test_bloom_customscan/sql/test_bloom_customscan.sql
index daae84a531a..8da2e0789e6 100644
--- a/src/test/modules/test_bloom_customscan/sql/test_bloom_customscan.sql
+++ b/src/test/modules/test_bloom_customscan/sql/test_bloom_customscan.sql
@@ -59,8 +59,57 @@ SELECT count(*) FROM cs_fact f JOIN cs_dim d ON f.a = d.id AND f.b = d.id2;
 SELECT test_bloom_cs_perkey_built() AS perkey_filters_built;
 SELECT test_bloom_cs_rejected_rows() > 0 AS filter_rejected_rows;
 
+-- Two independent joins: the provider should offer, and the planner should
+-- choose, a CustomPath expecting a combined filter from both joins.
+-- cpu_operator_cost is lowered so combining is robustly cheaper rather than a
+-- near-tie.
+CREATE TABLE cs_wide_a (id int, label text);
+CREATE TABLE cs_wide_b (id int, label text);
+INSERT INTO cs_wide_a SELECT g, 'a' || g FROM generate_series(1, 400) g;
+INSERT INTO cs_wide_b SELECT g, 'b' || g FROM generate_series(1, 400) g;
+ANALYZE cs_wide_a;
+ANALYZE cs_wide_b;
+
+SET test_bloom_customscan.enable = on;
+SET enable_seqscan = off;
+SET cpu_operator_cost = 0.0001;
+
+EXPLAIN (COSTS OFF, VERBOSE)
+SELECT count(*) FROM cs_fact f
+  JOIN cs_wide_a wa ON f.a = wa.id
+  JOIN cs_wide_b wb ON f.b = wb.id;
+
+SELECT test_bloom_cs_reset();
+SELECT count(*) FROM cs_fact f
+  JOIN cs_wide_a wa ON f.a = wa.id
+  JOIN cs_wide_b wb ON f.b = wb.id;
+SELECT test_bloom_cs_rejected_rows() > 0 AS filter_rejected_rows;
+
+-- Correctness: the result must be identical with and without the filters.
+SET test_bloom_customscan.enable = on;
+SET enable_seqscan = off;
+CREATE TEMP TABLE r_cs2 AS
+  SELECT f.a, count(*) AS n FROM cs_fact f
+    JOIN cs_wide_a wa ON f.a = wa.id
+    JOIN cs_wide_b wb ON f.b = wb.id
+  GROUP BY f.a;
+
+SET test_bloom_customscan.enable = off;
+SET enable_seqscan = on;
+CREATE TEMP TABLE r_plain2 AS
+  SELECT f.a, count(*) AS n FROM cs_fact f
+    JOIN cs_wide_a wa ON f.a = wa.id
+    JOIN cs_wide_b wb ON f.b = wb.id
+  GROUP BY f.a;
+
+SELECT count(*) AS cs_minus_plain
+  FROM (SELECT * FROM r_cs2 EXCEPT SELECT * FROM r_plain2) x;
+SELECT count(*) AS plain_minus_cs
+  FROM (SELECT * FROM r_plain2 EXCEPT SELECT * FROM r_cs2) x;
+
 -- cleanup
+RESET cpu_operator_cost;
 SET test_bloom_customscan.enable = off;
 SET enable_seqscan = on;
-DROP TABLE cs_fact, cs_dim;
+DROP TABLE cs_fact, cs_dim, cs_wide_a, cs_wide_b;
 DROP EXTENSION test_bloom_customscan;
diff --git a/src/test/modules/test_bloom_customscan/test_bloom_customscan.c b/src/test/modules/test_bloom_customscan/test_bloom_customscan.c
index 99338c7d361..30f53ff45c7 100644
--- a/src/test/modules/test_bloom_customscan/test_bloom_customscan.c
+++ b/src/test/modules/test_bloom_customscan/test_bloom_customscan.c
@@ -64,6 +64,8 @@ typedef struct BloomCSScanState
 }			BloomCSScanState;
 
 /* forward declarations */
+static void bloom_cs_add_path(RelOptInfo *rel, Cost startup_cost,
+							  Cost total_cost, List *filters);
 static Plan *bloom_cs_plan_custom_path(PlannerInfo *root, RelOptInfo *rel,
 									   CustomPath *best_path, List *tlist,
 									   List *clauses, List *custom_plans);
@@ -93,18 +95,57 @@ static const CustomExecMethods bloom_cs_exec_methods = {
 };
 
 /*
- * set_rel_pathlist_hook: offer a bloom-filter-capable CustomPath for plain
+ * bloom_cs_add_path
+ *	  Build and add one bloom-filter-capable CustomPath, optionally expecting
+ *	  the given set of pushed-down filters.  We don't do anything smart with
+ *	  the filters ourselves, so apply_expected_filters() supplies the same
+ *	  generic per-tuple probe cost and row-count adjustment core uses for
+ *	  stock scan types.
+ */
+static void
+bloom_cs_add_path(RelOptInfo *rel, Cost startup_cost, Cost total_cost,
+				  List *filters)
+{
+	CustomPath *cpath = makeNode(CustomPath);
+
+	cpath->path.pathtype = T_CustomScan;
+	cpath->path.parent = rel;
+	cpath->path.pathtarget = rel->reltarget;
+	cpath->path.param_info = NULL;
+	cpath->path.parallel_aware = false;
+	cpath->path.parallel_safe = false;
+	cpath->path.parallel_workers = 0;
+	cpath->path.rows = rel->rows;
+	cpath->path.startup_cost = startup_cost;
+	cpath->path.total_cost = total_cost;
+	cpath->path.pathkeys = NIL;
+
+	cpath->flags = CUSTOMPATH_SUPPORT_BLOOM_FILTERS;
+	cpath->custom_paths = NIL;
+	cpath->custom_private = NIL;
+	cpath->methods = &bloom_cs_path_methods;
+
+	apply_expected_filters(&cpath->path, filters);
+
+	add_path(rel, (Path *) cpath);
+}
+
+/*
+ * set_rel_pathlist_hook: offer bloom-filter-capable CustomPaths for plain
  * heap base relations.  We copy the cost of the existing sequential scan path
- * so join costing stays sane; the test forces the custom scan to be chosen
- * with "SET enable_seqscan = off" (the CustomPath keeps disabled_nodes = 0).
+ * so join costing stays sane.
+ *
+ * Besides the plain, filter-oblivious path, we also offer one CustomPath per
+ * combination of interesting Bloom filters this rel could receive from a
+ * hash join above it.
  */
 static void
 bloom_cs_set_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, Index rti,
 						  RangeTblEntry *rte)
 {
-	CustomPath *cpath;
 	Cost		startup_cost = 0;
 	Cost		total_cost = 0;
+	List	   *combinations;
 	ListCell   *lc;
 
 	if (prev_set_rel_pathlist_hook)
@@ -132,25 +173,16 @@ bloom_cs_set_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, Index rti,
 		}
 	}
 
-	cpath = makeNode(CustomPath);
-	cpath->path.pathtype = T_CustomScan;
-	cpath->path.parent = rel;
-	cpath->path.pathtarget = rel->reltarget;
-	cpath->path.param_info = NULL;
-	cpath->path.parallel_aware = false;
-	cpath->path.parallel_safe = false;
-	cpath->path.parallel_workers = 0;
-	cpath->path.rows = rel->rows;
-	cpath->path.startup_cost = startup_cost;
-	cpath->path.total_cost = total_cost;
-	cpath->path.pathkeys = NIL;
+	bloom_cs_add_path(rel, startup_cost, total_cost, NIL);
 
-	cpath->flags = CUSTOMPATH_SUPPORT_BLOOM_FILTERS;
-	cpath->custom_paths = NIL;
-	cpath->custom_private = NIL;
-	cpath->methods = &bloom_cs_path_methods;
+	combinations = find_bloom_filter_combinations(root, rel);
 
-	add_path(rel, (Path *) cpath);
+	foreach(lc, combinations)
+	{
+		List	   *combo = (List *) lfirst(lc);
+
+		bloom_cs_add_path(rel, startup_cost, total_cost, combo);
+	}
 }
 
 static Plan *
